package cpcns.dingZhi.zHUANTI.service.impl;

package .tmp;

import cpcns.base.common.User;
import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.tool.service.IDingZhiService;
import cpcns.dingZhi.zHUANTI.dao.IzhuanTiDengJiDanDao;
import cpcns.dingZhi.zHUANTI.model.zhaunTiDengJiDan;
import cpcns.dingZhi.zHUANTI.model.zhuanTiShenHe;
import cpcns.dingZhi.zHUANTI.service.IzhuanTiDengJiDanService;
import cpcns.utils.CommStatic;
import cpcns.utils.JDBCUtil;
import cpcns.utils.PagerVO;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("zhuanTiDengJiDanService")
public class zhuanTiDengJiDanServiceImpl extends DangAnBaseServiceImpl<zhaunTiDengJiDan> implements IzhuanTiDengJiDanService {
  @Autowired
  private IzhuanTiDengJiDanDao zhuanTiDengJiDanDao;
  
  @Autowired
  private IDingZhiService dingZhiService;
  
  public Boolean saveWenJian(Integer djdHbs, String wjHbss, String shuLiang) {
    Boolean crzt = Boolean.valueOf(false);
    String[] wenJianBiaoShistr = wjHbss.split(",");
    String[] shuLiangStr = shuLiang.split(",");
    if (wenJianBiaoShistr.length > 0) {
      String table = "D_ZHUANTISHENHEWENJIAN";
      Connection connection = null;
      connection = this.dingZhiService.getConn();
      if (connection != null) {
        try {
          Integer hbs = JDBCUtil.getCountInt(connection, "SELECT MAX(HANGBIAOSHI) FROM " + table);
          List<Map<String, Object>> MapList = new ArrayList<>();
          for (int i = 0; i < wenJianBiaoShistr.length; i++) {
            hbs = Integer.valueOf(hbs.intValue() + 4);
            Map<String, Object> dengJiWenJianGuanLian = new HashMap<>();
            dengJiWenJianGuanLian.put("HANGBIAOSHI", hbs);
            dengJiWenJianGuanLian.put("DENGJIDANBIAOSHI", djdHbs);
            dengJiWenJianGuanLian.put("GUANLIANWENJIANBIAOSHI", Integer.valueOf(Integer.parseInt(wenJianBiaoShistr[i])));
            dengJiWenJianGuanLian.put("SHULIANG", Integer.valueOf(Integer.parseInt(shuLiangStr[i])));
            MapList.add(dengJiWenJianGuanLian);
          } 
          hbs = Integer.valueOf(hbs.intValue() + 4);
          String dataType = this.zhuanTiDengJiDanDao.getDataType();
          connection.setAutoCommit(false);
          try {
            StringBuffer delSql = (new StringBuffer("delete from ")).append(table).append(" where dengJiDanBiaoShi = " + djdHbs);
            JDBCUtil.JDBCUpdateAndSave(connection, delSql.toString());
            Boolean insert = Boolean.valueOf(JDBCUtil.JDBCSaves(connection, table, "HANGBIAOSHI,DENGJIDANBIAOSHI,GUANLIANWENJIANBIAOSHI,SHULIANG", dataType, MapList));
            if (!insert.booleanValue()) {
              System.out.println("========插入文件遇到问题，文件未插入==================");
            } else {
              crzt = Boolean.valueOf(true);
            } 
            connection.commit();
            String upsql = "update G_BIAOLIUSHUIHAO SET liushuihao=" + hbs + " where biaoming='" + table + "' or biaoming='" + table.toUpperCase() + "'";
            JDBCUtil.JDBCUpdateAndSave(connection, upsql);
          } catch (Exception e) {
            connection.rollback();
            e.printStackTrace();
          } 
          connection.close();
        } catch (Exception e) {
          e.printStackTrace();
          try {
            connection.close();
          } catch (Exception e2) {
            e2.printStackTrace();
          } 
        } 
      } else {
        System.out.println("========获取数据库连接失败关联文件未保存，请检查S_MANAGE表配置");
      } 
    } 
    return crzt;
  }
  
  public PagerVO query_SQL(User user, Integer start, Integer rows, String table, Map<String, Object> map, String orderbysql) throws Exception {
    Map<String, Object> tp = new HashMap<>();
    StringBuffer sql = (new StringBuffer(" select * from ")).append(table).append(" where 1=1 ");
    Object dengJiDanZhuangTai = map.get("dengJiDanZhuangTai");
    Object quanXian = map.get("quanXian");
    if (dengJiDanZhuangTai != null && dengJiDanZhuangTai.equals("2")) {
      sql.append(" and hangBiaoShi in( select guanLianBiaoShi from D_ZHUANTISHENHE h where h.shenHeRenBiaoShi=:shenHeRenBiaoShi)");
      tp.put("shenHeRenBiaoShi", user.getBiaoShi());
    } else if (quanXian == null || !quanXian.equals("true")) {
      sql.append(" and dengJiRenBiaoShi=:dengJiRenBiaoShi");
      tp.put("dengJiRenBiaoShi", user.getBiaoShi());
    } 
    Object para = null;
    para = map.get("querystr");
    if (para != null && para != "") {
      Object menLei = map.get("menLei");
      if (menLei != null && menLei != "") {
        sql.append(" and menLei =:menLei");
        tp.put("menLei", menLei);
      } 
      CommStatic.zhuHeQueryJieXi_map(sql, tp, para.toString(), (String)map.get("zuHeType"), getDataType());
    } else {
      for (Map.Entry<String, Object> entry : map.entrySet()) {
        String mapKey = entry.getKey();
        String mapValue = (String)entry.getValue();
        if (!mapKey.equals("querystr") && !mapKey.equals("zuHeType") && !mapKey.equals("page") && !mapKey.equals("rows") && !mapKey.equals("order") && !mapKey.equals("sort") && !mapKey.equals("server") && !mapKey.equals("table") && !mapKey.equals("liuZhuanZhuangTai") && !mapKey.equals("hangBiaoShi") && !mapKey.equals("quanXian") && 
          StringUtils.isNotBlank(mapValue)) {
          if (mapKey.equals("faBuMuDi")) {
            String[] fbmd = mapValue.split(",");
            sql.append(" and faBuMuDi in(:faBuMuDi) ");
            tp.put(mapKey, fbmd);
            continue;
          } 
          if (mapKey.equals("fangShi")) {
            String[] fs = mapValue.split(",");
            sql.append(" and fangShi in(:fangShi) ");
            tp.put(mapKey, fs);
            continue;
          } 
          if (mapKey.equals("menLei")) {
            String[] ml = mapValue.split(",");
            sql.append(" and menLei in(:menLei) ");
            tp.put(mapKey, ml);
            continue;
          } 
          if (mapKey.contains("begin")) {
            mapKey = mapKey.substring(0, mapKey.indexOf("begin"));
            sql.append(" and ").append(mapKey).append(" >=:").append(mapKey);
            tp.put(mapKey, mapValue);
            continue;
          } 
          if (mapKey.contains("end")) {
            mapKey = mapKey.substring(0, mapKey.indexOf("end"));
            sql.append(" and ").append(mapKey).append(" <=:").append(mapKey);
            tp.put(mapKey, mapValue);
            continue;
          } 
          if (!mapKey.endsWith("like")) {
            sql.append(" and ").append(mapKey).append(" =:").append(mapKey);
            tp.put(mapKey, mapValue);
            continue;
          } 
          mapKey = mapKey.substring(0, mapKey.indexOf("like"));
          sql.append(" and ").append(mapKey).append(" like :").append(mapKey);
          tp.put(mapKey, "%" + mapValue.trim() + "%");
        } 
      } 
    } 
    return this.zhuanTiDengJiDanDao.querySQL(start, rows, sql.toString(), tp, orderbysql);
  }
  
  public PagerVO getWenJian(Integer start, Integer rows, String table, Map<String, Object> map, String orderbysql) throws Exception {
    Map<String, Object> tp = new HashMap<>();
    String sl = "";
    if (table.equals("D_ZHUANTI")) {
      sl = ",(select count(1) from D_ZHUANTISHEBIEMA f where f.guanlianbiaoshi=t.hangbiaoshi and (f.JIEYUEZHUANGTAI is null or f.JIEYUEZHUANGTAI=0)) as SHENGYULIANG ";
      Object gl = map.get("guanLianBiaoShi");
      if (gl != null && StringUtils.isNotBlank((String)gl)) {
        sl = String.valueOf(sl) + ",(select SHULIANG from D_ZHUANTISHENHEWENJIAN w where w.GUANLIANWENJIANBIAOSHI=t.hangbiaoshi AND W.DENGJIDANBIAOSHI=:dengJiDanBiaoShi) as JIEYUESHULIANG,(select CHUSHULIANG from D_ZHUANTISHENHEWENJIAN w where w.GUANLIANWENJIANBIAOSHI=t.hangbiaoshi AND W.DENGJIDANBIAOSHI=:dengJiDanBiaoShi) as CHUSHULIANG,(select RUSHJULIANG from D_ZHUANTISHENHEWENJIAN w where w.GUANLIANWENJIANBIAOSHI=t.hangbiaoshi AND W.DENGJIDANBIAOSHI=:dengJiDanBiaoShi) as RUSHJULIANG";
        sl = String.valueOf(sl) + ",(select LINGQUREN from D_ZHUANTISHENHEWENJIAN w where w.GUANLIANWENJIANBIAOSHI=t.hangbiaoshi AND W.DENGJIDANBIAOSHI=:dengJiDanBiaoShi) as LINGQUREN";
        sl = String.valueOf(sl) + ",(select GUIHUANREN from D_ZHUANTISHENHEWENJIAN w where w.GUANLIANWENJIANBIAOSHI=t.hangbiaoshi AND W.DENGJIDANBIAOSHI=:dengJiDanBiaoShi) as GUIHUANREN";
      } 
    } 
    StringBuffer sql = (new StringBuffer(" select t.HANGBIAOSHI,t.BIAOTI,t.DANGHAO,t.MIJI,t.CHENGWENRIQI,t.BAOGUANQIXIAN,t.GUIDANGNIANDU,t.QUANZONGHAO,t.zeRenZhe ")).append(sl).append(" from ").append(table).append(" t where zhuangTai not in(:zhuangTai) and shenHeZhuangTai>0 ");
    StringBuffer couSql = (new StringBuffer(" select count(1) from ")).append(table).append(" t where zhuangTai not in(:zhuangTai) and shenHeZhuangTai>0");
    StringBuffer where = new StringBuffer();
    Object guanLianBiaoShi = map.get("guanLianBiaoShi");
    if (guanLianBiaoShi == null || guanLianBiaoShi == "") {
      tp.put("zhuangTai", new String[] { "-1", "3", "4" });
    } else {
      tp.put("zhuangTai", new String[] { "-1", "3" });
    } 
    Object para = null;
    para = map.get("querystr");
    if (para != null && para != "") {
      Object menLei = map.get("menLei");
      if (menLei != null && menLei != "") {
        where.append(" and menLei =:menLei");
        tp.put("menLei", menLei);
      } 
      Object hangBiaoShis = map.get("hangBiaoShis");
      if (hangBiaoShis != null && StringUtils.isNotBlank((String)hangBiaoShis)) {
        where.append(" and hangBiaoShi not in (:hangBiaoShis)");
        String[] Value = hangBiaoShis.toString().split(",");
        tp.put("hangBiaoShis", Value);
      } 
      Object glbs = map.get("guanLianBiaoShi");
      if (glbs != null && StringUtils.isNotBlank((String)glbs)) {
        where.append(" and hangBiaoShi not in (select guanLianWenJianBiaoShi from D_ZHUANTISHENHEWENJIAN where dengJiDanBiaoShi =:dengJiDanBiaoShi) ");
        tp.put("dengJiDanBiaoShi", glbs);
      } 
      CommStatic.zhuHeQueryJieXi_map(sql, tp, para.toString(), (String)map.get("zuHeType"), getDataType());
    } else {
      for (Map.Entry<String, Object> entry : map.entrySet()) {
        String mapKey = entry.getKey();
        String mapValue = (String)entry.getValue();
        if (!mapKey.equals("querystr") && !mapKey.equals("zuHeType") && !mapKey.equals("page") && !mapKey.equals("rows") && !mapKey.equals("order") && !mapKey.equals("sort") && !mapKey.equals("server") && !mapKey.equals("table") && !mapKey.equals("liuZhuanZhuangTai") && !mapKey.equals("faBuMuDi") && !mapKey.equals("yuanFaBuMuDi") && !mapKey.equals("fangShi") && !mapKey.equals("leiXing") && !mapKey.equals("suoYou") && 
          StringUtils.isNotBlank(mapValue)) {
          if (mapKey.contains("begin")) {
            mapKey = mapKey.substring(0, mapKey.indexOf("begin"));
            where.append(" and ").append(mapKey).append(" >=:").append(mapKey);
            tp.put(mapKey, mapValue);
            continue;
          } 
          if (mapKey.contains("end")) {
            mapKey = mapKey.substring(0, mapKey.indexOf("end"));
            where.append(" and ").append(mapKey).append(" <=:").append(mapKey);
            tp.put(mapKey, mapValue);
            continue;
          } 
          if (!mapKey.endsWith("like")) {
            if (mapKey.equals("guanLianBiaoShi")) {
              where.append(" and hangBiaoShi in (select guanLianWenJianBiaoShi from D_ZHUANTISHENHEWENJIAN where dengJiDanBiaoShi =:dengJiDanBiaoShi)");
              tp.put("dengJiDanBiaoShi", mapValue);
              continue;
            } 
            if (mapKey.equals("glbs")) {
              where.append(" and hangBiaoShi not in (select guanLianWenJianBiaoShi from D_ZHUANTISHENHEWENJIAN where dengJiDanBiaoShi =:dengJiDanBiaoShi)");
              tp.put("dengJiDanBiaoShi", mapValue);
              continue;
            } 
            if (mapKey.equals("hangBiaoShis")) {
              where.append(" and hangBiaoShi not in (:hangBiaoShis)");
              String[] Value = mapValue.split(",");
              tp.put("hangBiaoShis", Value);
              continue;
            } 
            where.append(" and ").append(mapKey).append(" =:").append(mapKey);
            tp.put(mapKey, mapValue);
            continue;
          } 
          mapKey = mapKey.substring(0, mapKey.indexOf("like"));
          where.append(" and ").append(mapKey).append(" like :").append(mapKey);
          tp.put(mapKey, "%" + mapValue.trim() + "%");
        } 
      } 
    } 
    return this.zhuanTiDengJiDanDao.queryBySql(String.valueOf(sql.toString()) + where + orderbysql, String.valueOf(couSql.toString()) + where, tp, start.intValue(), rows.intValue());
  }
  
  public String addShenPiMoBan(Integer shenQingDanBiaoShi, String mbHBS) {
    String falg = "0";
    if (shenQingDanBiaoShi != null) {
      try {
        StringBuffer sql = new StringBuffer("select shr.ciXu,shr.shenHeRenMingCheng,shr.shenHeRenBiaoShi,shr.shenHeRenBuMen,shr.shenHeRenBuMenBiaoShi from D_ShenPiRenYuan shr,D_ShenPiYuShe ys where shr.guanLianBiaoShi=ys.hangBiaoShi and ys.hangBiaoShi=" + mbHBS + " order by shr.ciXu");
        List<Object[]> list = getList(sql.toString());
        if (list != null && list.size() > 0) {
          for (int i = 0; i < list.size(); i++) {
            Object[] shenPiRen = list.get(i);
            zhuanTiShenHe t = new zhuanTiShenHe();
            t.setHangBiaoShi(Integer.valueOf(getPk("D_ZHUANTISHENHE")));
            t.setCiXu(Integer.valueOf(Integer.parseInt(shenPiRen[0].toString())));
            t.setShenHeRenMingCheng(shenPiRen[1].toString());
            t.setShenHeRenBiaoShi(Integer.valueOf(Integer.parseInt(shenPiRen[2].toString())));
            t.setShenHeRenBuMen(shenPiRen[3].toString());
            t.setShenHeRenBuMenBiaoShi(Integer.valueOf(Integer.parseInt(shenPiRen[4].toString())));
            t.setGuanLianBiaoShi(shenQingDanBiaoShi);
            if ("1".equals(shenPiRen[0].toString())) {
              t.setLiuZhuanZhuangTai(Integer.valueOf(2));
              t.setJieShouRiQi(new Date());
            } else {
              t.setLiuZhuanZhuangTai(Integer.valueOf(1));
            } 
            this.zhuanTiDengJiDanDao.save(t);
          } 
        } else {
          falg = "2";
        } 
      } catch (Exception e) {
        e.printStackTrace();
        return "1";
      } 
    } else {
      falg = "1";
    } 
    return falg;
  }
  
  public void deleteBySql(String sql) {
    this.zhuanTiDengJiDanDao.update(sql);
  }
  
  public void updateORSave(String sql) {
    this.zhuanTiDengJiDanDao.updateORSave(sql);
  }
}
